
//  DrawingSuorakaiteitaApplet.java  (c) 2006 Kari Laitinen

//  http://www.naturalprogramming.com/

//  2004-12-13  Tiedosto luotu.
//  2006-12-04  Viimeisin muutos.

//  Tm on jatkokehitetty versio ohjelmasta DrawingLinesApplet.java
//  Tm osaa piirt suorakaiteen hiiren liikkeen alkupisteen
//  ja loppupisteen mrittmll tavalla.

import java.awt.* ;
import java.awt.event.*;
import javax.swing.* ;

public class DrawingSuorakaiteitaApplet extends JApplet
                                     implements MouseListener,
                                                MouseMotionListener
{
   final int MAKSIMI_SUORAKAITEIDEN_MAARA = 10 ; 
   Point alkupisteet[]   =  new Point[ MAKSIMI_SUORAKAITEIDEN_MAARA ] ;
   Point loppupisteet[]  =  new Point[ MAKSIMI_SUORAKAITEIDEN_MAARA ] ;
   Point uusi_alkupiste ;
   Point uusi_loppupiste ;
   int   suorakaiteiden_maara    =  0 ;

   public void init()
   {
      getContentPane().setBackground( Color.white ) ; // taustavrin asetus

      //  Event listeners must be registered.

      addMouseListener( this ) ;
      addMouseMotionListener( this ) ;
   }

   //  The following dummy functions are needed
   //  to satisfy listener interfaces.
   public void mouseMoved( MouseEvent event ) {}
   public void mouseClicked( MouseEvent event ) {}
   public void mouseEntered( MouseEvent event ) {}
   public void mouseExited( MouseEvent event ) {}

   public void mousePressed( MouseEvent event )
   {
      if ( suorakaiteiden_maara  <  MAKSIMI_SUORAKAITEIDEN_MAARA )
      {
          uusi_alkupiste  =  event.getPoint() ;
      }
   }

   public void mouseReleased( MouseEvent event )
   {
      if ( suorakaiteiden_maara  <  MAKSIMI_SUORAKAITEIDEN_MAARA ) 
      {
        alkupisteet[ suorakaiteiden_maara ]   =  uusi_alkupiste;
        loppupisteet[ suorakaiteiden_maara ]  =  event.getPoint() ;

        suorakaiteiden_maara ++ ;
        uusi_loppupiste  = null ;
        uusi_alkupiste   = null ;
        repaint() ;
      }
   }

   public void mouseDragged( MouseEvent event )
   {
      if ( suorakaiteiden_maara  <  MAKSIMI_SUORAKAITEIDEN_MAARA )
      {
         uusi_loppupiste = event.getPoint() ;

         repaint();
      }
   }


   void piirra_suorakaide( Graphics graphics,
                           Point    alkupiste,
                           Point    loppupiste )
   {
      int piirtopaikka_x = alkupiste.x ;
      int piirtopaikka_y = alkupiste.y ;
      int suorakaiteen_leveys = loppupiste.x - alkupiste.x ;
      int suorakaiteen_korkeus = loppupiste.y - alkupiste.y ;

      if ( suorakaiteen_leveys < 0 )
      {
         suorakaiteen_leveys = - suorakaiteen_leveys ;
         piirtopaikka_x -= suorakaiteen_leveys ;

         /*  Em. ksky tarkoittaa samaa kuin

             piirtopaikka_x  =  piirtopaikka_x - suorakaiteen_leveys ;
         */
      }

      if ( suorakaiteen_korkeus < 0 )
      {
         suorakaiteen_korkeus  =  - suorakaiteen_korkeus ;
         piirtopaikka_y  -=  suorakaiteen_korkeus ;         
      }

      graphics.drawRect( piirtopaikka_x,
                         piirtopaikka_y,
                         suorakaiteen_leveys,
                         suorakaiteen_korkeus ) ;
   }

   public void paint( Graphics graphics )
   {
      super.paint( graphics ) ;

      for ( int suorakaiteen_indeksi  =  0 ;
                suorakaiteen_indeksi  <  suorakaiteiden_maara ;
                suorakaiteen_indeksi  ++ )
      {

         piirra_suorakaide( graphics,
                            alkupisteet[ suorakaiteen_indeksi ],
                            loppupisteet[ suorakaiteen_indeksi ]  ) ;
      }

      graphics.setColor( Color.red ) ;

      if ( uusi_loppupiste != null )
      {
         piirra_suorakaide( graphics,
                            uusi_alkupiste,
                            uusi_loppupiste ) ;
      }

      if ( suorakaiteiden_maara  ==  MAKSIMI_SUORAKAITEIDEN_MAARA )
      {
         graphics.drawString( "Ei mahdu enempaa suorakaiteita.", 0, 300 ) ;
      }
   }
}



